
-- BigDebuffs by Jordon

BigDebuffs = LibStub("AceAddon-3.0"):NewAddon("BigDebuffs", "AceEvent-3.0", "AceHook-3.0")

LoadAddOn("Blizzard_CompactRaidFrames")

-- Defaults
local defaults = {
	profile = {
		raidFrames = {
			maxDebuffs = 1,
			anchor = "INNER",
			enabled = true,
			cooldownCount = true,
			hideBliz = true,
			redirectBliz = false,
			increaseBuffs = false,
			cc = 45,
			dispellable = {
				cc = 60,
				roots = 45,
			},
			roots = 45,
			special = 45,
			default = 30,
			specialList = {
				[88611] = true, -- Smoke Bomb
				[81261] = true, -- Solar Beam
				[30108] = true, -- Unstable Affliction
				[34914] = true, -- Vampiric Touch
			},
		},
		unitFrames = {
			enabled = true,
			cooldownCount = true,
			tooltips = true,
			player = true,
			focus = true,
			target = true,
			pet = true,
			cc = true,
			immunities = true,
			roots = true,
			buffs = true,
		},
		priority = {
			["cc"] = 80,
			["immunities"] = 60,
			["buffs"] = 40,
			["roots"] = 20,
		},
		spells = {},
	}
}

-- Show one of these when a big debuff is displayed
BigDebuffs.SpecialDebuffs = {
	88611, -- Smoke Bomb
	81261, -- Solar Beam
	30108, -- Unstable Affliction
	34914, -- Vampiric Touch
}

BigDebuffs.Debuffs = {
	-- CC
	[33786]  = { type = "cc", priority = true }, -- Cyclone
	[605]    = { type = "cc", priority = true }, -- Dominate Mind (Mind Control)
	[163505] = { type = "cc" }, -- Rake
	[108194] = { type = "cc" }, -- Asphyxiate
	[91800]  = { type = "cc" }, -- Gnaw
	[91797]  = { type = "cc" }, -- Monstrous Blow
	[5211]   = { type = "cc" }, -- Mighty Bash
	[22570]  = { type = "cc" }, -- Maim
	[99]     = { type = "cc" }, -- Incapacitating Roar
	[24394]  = { type = "cc" }, -- Intimidation
	[119392] = { type = "cc" }, -- Charging Ox Wave
	[119381] = { type = "cc" }, -- Leg Sweep
	[120086] = { type = "cc" }, -- Fists of Fury
	[115078] = { type = "cc" }, -- Paralysis
	[5246]   = { type = "cc" }, -- Intimidating Shout
	[6770]   = { type = "cc" }, -- Sap
	[408]    = { type = "cc" }, -- Kidney Shot
	[2094]   = { type = "cc" }, -- Blind
	[1833]   = { type = "cc" }, -- Cheap Shot
	[1776]   = { type = "cc" }, -- Gouge
	[77505]  = { type = "cc" }, -- Earthquake
	[22703]  = { type = "cc" }, -- Infernal Awakening
	[132168] = { type = "cc" }, -- Shockwave
	[132169] = { type = "cc" }, -- Storm Bolt
	[20549]  = { type = "cc" }, -- War Stomp
	[107079] = { type = "cc" }, -- Quaking Palm
	[137143] = { type = "cc" }, -- Blood Horror
	[44572]  = { type = "cc" }, -- Deep Freeze
	[115001] = { type = "cc" }, -- Remorseless Winter
	[47476] = { type = "cc" }, -- Strangulate
		[115502] = { type = "cc", parent = 47476 }, -- Strangulate (Asphyxiate)
	[19386]  = { type = "cc" }, -- Wyvern Sting
	[3355]   = { type = "cc" }, -- Freezing Trap
	[117526] = { type = "cc" }, -- Binding Shot
	[118]    = { type = "cc" }, -- Polymorph
		[61305]  = { type = "cc", parent = 118 }, -- Polymorph Black Cat
		[28272]  = { type = "cc", parent = 118 }, -- Polymorph Pig
		[61721]  = { type = "cc", parent = 118 }, -- Polymorph Rabbit
		[61780]  = { type = "cc", parent = 118 }, -- Polymorph Turkey
		[28271]  = { type = "cc", parent = 118 }, -- Polymorph Turtle
	[1330]   = { type = "cc" }, -- Garrote - Silence
	[82691]  = { type = "cc" }, -- Ring of Frost
	[31661]  = { type = "cc" }, -- Dragon's Breath
	[102051] = { type = "cc" }, -- Frostjaw
	[853]    = { type = "cc" }, -- Hammer of Justice
	[105593] = { type = "cc" }, -- Fist of Justice
	[10326]  = { type = "cc" }, -- Turn Evil
	[20066]  = { type = "cc" }, -- Repentance
	[119072] = { type = "cc" }, -- Holy Wrath
	[31935]  = { type = "cc" }, -- Avengers Shield
	[8122]   = { type = "cc" }, -- Psychic Scream
	[9484]   = { type = "cc" }, -- Shackle Undead
	[15487]  = { type = "cc" }, -- Silence
	[64044]  = { type = "cc" }, -- Psychic Horror
	[87204]  = { type = "cc" }, -- Sin and Punishment
	[51514]  = { type = "cc" }, -- Hex
	[118905] = { type = "cc" }, -- Static Charge (Capacitor Totem)
	[118699] = { type = "cc" }, -- Fear
		[130616] = { type = "cc", parent = 118699 }, -- Fear (Glyph of Fear)
	[5484]   = { type = "cc" }, -- Howl of Terror
	[30283]  = { type = "cc" }, -- Shadowfury
	[6358]   = { type = "cc" }, -- Seduction
	[115268] = { type = "cc" }, -- Mesmerize
	[6789]   = { type = "cc" }, -- Mortal Coil
	[710]    = { type = "cc" }, -- Banish
	[88625]  = { type = "cc" }, -- Holy Word: Chastise
	[137460] = { type = "cc" }, -- Incapacitated
	[129597] = { type = "cc" }, -- Arcane Torrent
		[28730]  = { type = "cc", parent = 129597 }, -- Arcane Torrent
		[25046]  = { type = "cc", parent = 129597 }, -- Arcane Torrent
		[50613]  = { type = "cc", parent = 129597 }, -- Arcane Torrent
		[69179]  = { type = "cc", parent = 129597 }, -- Arcane Torrent
		[155145] = { type = "cc", parent = 129597 }, -- Arcane Torrent
		[80483]  = { type = "cc", parent = 129597 }, -- Arcane Torrent
	[31117]  = { type = "cc" }, -- Unstable Affliction (Silence)
	[155335] = { type = "cc" }, -- Touched by Ice
	[88611]  = { type = "cc" }, -- Smoke Bomb
	[81261]  = { type = "cc" }, -- Solar Beam
	[123393] = { type = "cc" }, -- Breath of Fire
	[118345] = { type = "cc" }, -- Pulverize
	[105421] = { type = "cc" }, -- Blinding Light
	[114238] = { type = "cc" }, -- Fae Silence
	[89766]  = { type = "cc" }, -- Axe Toss

	-- Immunities
	[45438]  = { type = "immunities", priority = true }, -- Ice Block
	[115760] = { type = "immunities", priority = true }, -- Glyph of Ice Block
	[642]    = { type = "immunities", priority = true }, -- Divine Shield
	[19263]  = { type = "immunities", priority = true }, -- Deterrence
		[148467] = { type = "immunities", priority = true }, -- Deterrence (Glyph of Mirrored Blades)
	[157913] = { type = "immunities", priority = true }, -- Evanesce
	[51690]  = { type = "immunities", priority = true }, -- Killing Spree
	[104773] = { type = "immunities", priority = true }, -- Unending Resolve
	[46924]  = { type = "immunities" }, -- Bladestorm
	[31224]  = { type = "immunities" }, -- Cloak of Shadows
	[114029] = { type = "immunities" }, -- Safeguard
	[48707]  = { type = "immunities" }, -- Anti-Magic Shell
	[8178]   = { type = "immunities" }, -- Grounding Totem
		[89523]  = { type = "immunities", parent = 8178 }, -- Grounding Totem (Glyph of Grounding Totem)
	[23920]  = { type = "immunities" }, -- Spell Reflection
		[114028] = { type = "immunities", parent = 23920 }, -- Mass Spell Reflection
	[159546] = { type = "immunities" }, -- Glyph of Zen Focus
	[159630] = { type = "immunities" }, -- Shadow Magic
	[159438] = { type = "immunities" }, -- Glyph of Enchanted Bark
	[159652] = { type = "immunities" }, -- Glyph of Spiritwalker's Aegis
	[115018] = { type = "immunities" }, -- Desecrated Ground
	[31821]  = { type = "immunities" }, -- Devotion Aura

	-- Buffs (prioritize damage reductions)
	[871]    = { type = "buffs", priority = true }, -- Shield Wall
	[19574]  = { type = "buffs", priority = true }, -- Bestial Wrath
	[84747]  = { type = "buffs", priority = true }, -- Deep Insight
	[108271] = { type = "buffs", priority = true }, -- Astral Shift
	[157128] = { type = "buffs", priority = true }, -- Saved by the Light
	[33206]  = { type = "buffs", priority = true }, -- Pain Suppression
	[116849] = { type = "buffs", priority = true }, -- Life Cocoon
	[47788]  = { type = "buffs", priority = true }, -- Guardian Spirit
	[47585]  = { type = "buffs", priority = true }, -- Dispersion
	[122783] = { type = "buffs", priority = true }, -- Diffuse Magic
	[178858] = { type = "buffs", priority = true }, -- Contender
	[41425]  = { type = "buffs" }, -- Hypothermia
	[131894] = { type = "buffs" }, -- A Murder of Crows
	[152151] = { type = "buffs" }, -- Shadow Reflection
	[114916] = { type = "buffs" }, -- Execution Sentence
	[114917] = { type = "buffs" }, -- Stay of Execution
	[114049] = { type = "buffs" }, -- Ascendance
		[114050] = { type = "buffs", parent = 114049 }, -- Ascendance (Elemental)
		[114051] = { type = "buffs", parent = 114049 }, -- Ascendance (Enhancement)
		[114052] = { type = "buffs", parent = 114049 }, -- Ascendance (Restoration)
	[130736] = { type = "buffs" }, -- Soul Reaper (Blood)
		[114866] = { type = "buffs", parent = 130736 }, -- Soul Reaper (Unholy)
		[130735] = { type = "buffs", parent = 130736 }, -- Soul Reaper (Frost)
	[98007]  = { type = "buffs" }, -- Spirit Link
	[79140]  = { type = "buffs" }, -- Vendetta
	[12043]  = { type = "buffs" }, -- Presence of Mind
	[16188]  = { type = "buffs" }, -- Ancestral Swiftness
	[132158] = { type = "buffs" }, -- Nature's Swiftness
	[6346]   = { type = "buffs" }, -- Fear Ward
	[5277]   = { type = "buffs" }, -- Evasion
	[49039]  = { type = "buffs" }, -- Lichborne
	[77606]  = { type = "buffs" }, -- Dark Simulacrum
	[102560] = { type = "buffs" }, -- Incarnation: Chosen of Elune
	[117679] = { type = "buffs" }, -- Incarnation: Tree of Life
	[102543] = { type = "buffs" }, -- Incarnation: King of the Jungle
	[118038] = { type = "buffs" }, -- Die by the Sword
	[74001]  = { type = "buffs" }, -- Combat Readiness
	[51713]  = { type = "buffs" }, -- Shadow Dance
	[13750]  = { type = "buffs" }, -- Adrenaline Rush
	[137562] = { type = "buffs" }, -- Nimble Brew
	[30823]  = { type = "buffs" }, -- Shamanistic Rage
	[1719]   = { type = "buffs" }, -- Recklessness
	[84746]  = { type = "buffs" }, -- Moderate Insight
	[1044]   = { type = "buffs" }, -- Hand of Freedom
	[1966]   = { type = "buffs" }, -- Feint
	[10060]  = { type = "buffs" }, -- Power Infusion
	[108291] = { type = "buffs" }, -- Heart of the Wild (Balance)
		[108292] = { type = "buffs", parent = 108291 }, -- Heart of the Wild (Feral)
		[108293] = { type = "buffs", parent = 108291 }, -- Heart of the Wild (Guardian)
		[108294] = { type = "buffs", parent = 108291 }, -- Heart of the Wild (Restoration)
	[61336]  = { type = "buffs" }, -- Survival Instincts
	[172786] = { type = "buffs" }, -- Drink
	[167152] = { type = "buffs" }, -- Refreshment
	[112071] = { type = "buffs" }, -- Celestial Alignment
	[5384]   = { type = "buffs" }, -- Feign Death
	[102342] = { type = "buffs" }, -- Ironbark
	[108978] = { type = "buffs" }, -- Alter Time
	[6940]   = { type = "buffs" }, -- Hand of Sacrifice
	[97463]  = { type = "buffs" }, -- Rallying Cry
	[170856] = { type = "buffs" }, -- Nature's Grasp
	[22812]  = { type = "buffs" }, -- Barkskin
	[110959] = { type = "buffs" }, -- Greater Invisibility
	[114239] = { type = "buffs" }, -- Phantasm
	[18499]  = { type = "buffs" }, -- Berserker Rage
	[31842]  = { type = "buffs" }, -- Avenging Wrath
	[106951] = { type = "buffs" }, -- Berserk
	[110913] = { type = "buffs" }, -- Dark Bargain
	[81782]  = { type = "buffs" }, -- Power Word: Barrier
	[30884]  = { type = "buffs" }, -- Nature's Guardian
	[155835] = { type = "buffs" }, -- Bristling Fur
	[62606]  = { type = "buffs" }, -- Savage Defense
	[1022]   = { type = "buffs" }, -- Hand of Protection
	[48743]  = { type = "buffs" }, -- Death Pact
	[119032] = { type = "buffs" }, -- Spectral Guise
	[31850]  = { type = "buffs" }, -- Ardent Defender
	[124974] = { type = "buffs" }, -- Nature's Vigil
	[115176] = { type = "buffs" }, -- Zen Meditation
	[120954] = { type = "buffs" }, -- Fortifying Brew
	[118347] = { type = "buffs" }, -- Reinforce
	[12042]  = { type = "buffs" }, -- Arcane Power
	[114030] = { type = "buffs" }, -- Vigilance
	[498]    = { type = "buffs" }, -- Divine Protection
	[111397] = { type = "buffs" }, -- Blood Horror (Buff)
	[122470] = { type = "buffs" }, -- Touch of Karma
	[48792]  = { type = "buffs" }, -- Icebound Fortitude
	[51271]  = { type = "buffs" }, -- Pillar of Frost
	[12472]  = { type = "buffs" }, -- Icy Veins
	[77801]  = { type = "buffs" }, -- Dark Soul
		[113860] = { type = "buffs", parent = 77801 }, -- Dark Soul (Misery)
		[113861] = { type = "buffs", parent = 77801 }, -- Dark Soul (Knowledge)
		[113858] = { type = "buffs", parent = 77801 }, -- Dark Soul (Instability)
	[122278] = { type = "buffs" }, -- Dampen Harm
	[152279] = { type = "buffs" }, -- Breath of Sindragosa
	[55233]  = { type = "buffs" }, -- Vampiric Blood
	[114039] = { type = "buffs" }, -- Hand of Purity
	[16166]  = { type = "buffs" }, -- Elemental Mastery
	[107574] = { type = "buffs" }, -- Avatar
	[53480]  = { type = "buffs" }, -- Roar of Sacrifice
	[55694]  = { type = "buffs" }, -- Enraged Regeneration
	[114896] = { type = "buffs" }, -- Windwalk Totem
	[12975]  = { type = "buffs" }, -- Last Stand
	[86659]  = { type = "buffs" }, -- Guardian of Ancient Kings
	[108416] = { type = "buffs" }, -- Sacrificial Pact
	[83853]  = { type = "buffs" }, -- Combustion

	-- Roots
	[122]    = { type = "roots" }, -- Frost Nova
		[33395] = { type = "roots", parent = 122 }, -- Freeze
	[339]    = { type = "roots" }, -- Entangling Roots
		[113770] = { type = "roots", parent = 339 }, -- Entangling Roots
		[170855] = { type = "roots", parent = 339 }, -- Nature's Grasp
	[53148]  = { type = "roots" }, -- Charge (Hunter)
		[105771] = { type = "roots" }, -- Charge (Warrior)
	[63685]  = { type = "roots" }, -- Frozen Power
	[64695]  = { type = "roots" }, -- Earthgrab Totem
	[87194]  = { type = "roots" }, -- Glyph of Mind Blast
	[96294]  = { type = "roots" }, -- Chains of Ice
	[102359] = { type = "roots" }, -- Mass Entanglement
	[111340] = { type = "roots" }, -- Ice Ward
	[114404] = { type = "roots" }, -- Void Tendrils
	[116706] = { type = "roots" }, -- Disable
	[135373] = { type = "roots" }, -- Entrapment
	[136634] = { type = "roots" }, -- Narrow Escape
	[55536]  = { type = "roots" }, -- Frostweave Net
	[157997] = { type = "roots" }, -- Ice Nova
	[45334] = { type = "roots" }, -- Wild Charge
}

local specDispel = {
	[62] = { -- Aracne Mage
		["Curse"] = true,
	},
	[63] = { -- Frost Mage
		["Curse"] = true,
	},
	[64] = { -- Fire Mage
		["Curse"] = true,
	},
	[65] = { -- Holy Paladin
		["Magic"] = true,
		["Poison"] = true,
		["Disease"] = true,
	},
	[66] = { -- Protection Paladin
		["Poison"] = true,
		["Disease"] = true,
	},
	[70] = { -- Retribution Paladin
		["Poison"] = true,
		["Disease"] = true,
	},
	[102] = { -- Balance Druid
		["Curse"] = true,
		["Poison"] = true,
	},
	[103] = { -- Feral Druid
		["Curse"] = true,
		["Poison"] = true,
	},
	[104] = { -- Guardian Druid
		["Curse"] = true,
		["Poison"] = true,
	},
	[105] = { -- Restoration Druid
		["Magic"] = true,
		["Curse"] = true,
		["Poison"] = true,
	},
	[256] = { -- Discipline Priest
		["Magic"] = true,
		["Disease"] = true,
	},
	[257] = { -- Holy Priest
		["Magic"] = true,
		["Disease"] = true,
	},
	[258] = { -- Shadow Priest
		["Magic"] = true,
	},
	[262] = { -- Elemental Shaman
		["Curse"] = true,
	},
	[263] = { -- Enhancement Shaman
		["Curse"] = true,
	},
	[264] = { -- Restoration Shaman
		["Magic"] = true,
		["Curse"] = true,
	},
	[268] = { -- Brewmaster Monk
		["Poison"] = true,
		["Disease"] = true,
	},
	[269] = { -- Windwalker Monk
		["Poison"] = true,
		["Disease"] = true,
	},
	[270] = { -- Mistweaver Monk
		["Magic"] = true,
		["Poison"] = true,
		["Disease"] = true,
	},
}

-- Make sure we always see these debuffs, but don't make them bigger
BigDebuffs.PriorityDebuffs = {
	30108,  -- Unstable Affliction
	34914,  -- Vampiric Touch
	102355, -- Faerie Swarm
	770,    -- Faerie Fire
	2944,   -- Devouring Plague
	114866, -- Soul Reaper (Blood)
	130736, -- Soul Reaper (Unholy)
	130735, -- Soul Reaper (Frost)
	114916, -- Execution Sentence
}

local units = {
	["player"] = {
		{
			frame = "ElvUF_Player",
			SetPoint = {
				"TOPLEFT",
				"ElvUF_Player",
				"TOPRIGHT",
				0,
				0,
			},
			size = "ElvUF_Player",
		},
		{
			name = "ZPerl",
			frame = "XPerl_PlayerportraitFrame",
		}, 
		{
			name = "Perl",
			frame = "Perl_Player_Portrait",
		},
		{
			name = "Blizzard",
			frame = "PlayerPortrait",
		},
	},
	["target"] = {
		{
			frame = "ElvUF_Target",
			SetPoint = {
				"TOPLEFT",
				"ElvUF_Target",
				"TOPRIGHT",
				0,
				0,
			},
			size = "ElvUF_Target",
		},
		{
			name = "ZPerl",
			frame = "XPerl_TargetportraitFrame",
		},
		{
			name = "Perl",
			frame = "Perl_Target_Portrait",
		},
		{
			name = "Blizzard",
			frame = "TargetFramePortrait",
		},
	},
	["focus"] = {
		{
			frame = "ElvUF_Focus",
			SetPoint = {
				"TOPLEFT",
				"ElvUF_Focus",
				"TOPRIGHT",
				0,
				0,
			},
			size = "ElvUF_Focus",
		},
		{
			name = "ZPerl",
			frame = "XPerl_FocusportraitFrame",
		},
		{
			name = "Perl",
			frame = "Perl_Focus_Portrait",
		},
		{
			name = "Blizzard",
			frame = "FocusFramePortrait"
		},
	},
	["pet"] = {
		{
			frame = "ElvUF_Pet",
			SetPoint = {
				"TOPLEFT",
				"ElvUF_Pet",
				"TOPRIGHT",
				0,
				0,
			},
			size = "ElvUF_Pet",
		},
		{
			name = "ZPerl",
			frame = "XPerl_Player_PetportraitFrame",
		},
		{
			name = "Perl",
			frame = "Perl_Player_Pet_Portrait",
		},
		{
			name = "Blizzard",
			frame = "PetPortrait",
		},
	},
}

function BigDebuffs:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BigDebuffsDB", defaults, true)
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	self.frames = {}
	self.UnitFrames = {}
	self:SetupOptions()
end

local function HideBigDebuffs(frame)
	if not frame.BigDebuffs then return end
	for i = 1, #frame.BigDebuffs do
		frame.BigDebuffs[i]:Hide()
	end
end

function BigDebuffs:Refresh()
	for frame, _ in pairs(self.frames) do
		HideBigDebuffs(frame)
		if frame and frame.BigDebuffs then self:AddBigDebuffs(frame) end
	end
	for unit, frame in pairs(self.UnitFrames) do
		frame:Hide()
		frame.cooldown:SetHideCountdownNumbers(not self.db.profile.unitFrames.cooldownCount)
		frame.cooldown.noCooldownCount = not self.db.profile.unitFrames.cooldownCount
		self:UNIT_AURA(nil, unit)
	end
end

function BigDebuffs:OnEnable()
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("UNIT_PET")
	self:PLAYER_TALENT_UPDATE()
	for unit,_ in pairs(units) do
		local frame = CreateFrame("Button", "BigDebuffs" .. unit .. "Frame", UIParent, "BigDebuffsUnitFrameTemplate")
		frame.icon:SetDrawLayer("BORDER")
		frame:EnableMouse(false)

		-- Find a frame to attach to
		for i = 1, #units[unit] do
			local v = units[unit][i]
			if _G[v.frame] then
				frame.anchor = _G[v.frame]
				frame.blizzard = v.name == "Blizzard"
				frame.point = v.SetPoint
				frame.size = v.size
				frame.unit = unit
				break
			end
		end

		if frame.blizzard then
			-- Blizzard Frame
			frame:SetParent(frame.anchor:GetParent())
			frame:SetFrameLevel(frame.anchor:GetParent():GetFrameLevel())
			frame.cooldown:SetFrameLevel(frame.anchor:GetParent():GetFrameLevel())
			frame.anchor:SetDrawLayer("BACKGROUND")
			frame.cooldown:SetSwipeTexture("Interface\\CHARACTERFRAME\\TempPortraitAlphaMaskSmall")
		else
			frame:SetParent(frame.anchor)
			frame:SetFrameLevel(99)
		end

		if frame.point then
			frame:SetPoint(unpack(frame.point))
		else
			frame:SetAllPoints(frame.anchor)
		end

		if frame.size then
			local height = (type(frame.size) == "number" and frame.size) or (_G[frame.size] and _G[frame.size]:GetHeight())
			if height then frame:SetSize(height, height) end
		end

		self.UnitFrames[unit] = frame
	end

	-- Prevent OmniCC finish animations
	if OmniCC then
		self:RawHook(OmniCC, "TriggerEffect", function(object, cooldown)
			local name = cooldown:GetName()
			if name and name:find("BigDebuffs") then return end
			self.hooks[OmniCC].TriggerEffect(object, cooldown)
		end)
	end

end

local MAX_BUFFS = 6

function BigDebuffs:AddBigDebuffs(frame)
	if not frame or not frame.displayedUnit or not UnitIsPlayer(frame.displayedUnit) then return end
	local frameName = frame:GetName()
	if self.db.profile.raidFrames.increaseBuffs then
		for i = 4, MAX_BUFFS do
			local buffPrefix = frameName .. "Buff"
			local buffFrame = _G[buffPrefix .. i] or CreateFrame("Button", buffPrefix .. i, frame, "CompactBuffTemplate")
			buffFrame:ClearAllPoints()
			if math.fmod(i - 1, 3) == 0 then
				buffFrame:SetPoint("BOTTOMRIGHT", _G[buffPrefix .. i - 3], "TOPRIGHT")
			else
				buffFrame:SetPoint("BOTTOMRIGHT", _G[buffPrefix .. i - 1], "BOTTOMLEFT")
			end
		end
	end

	frame.BigDebuffs = frame.BigDebuffs or {}
	local max = self.db.profile.raidFrames.maxDebuffs + 1 -- add a frame for special debuffs
	for i = 1, max do
		local big = frame.BigDebuffs[i] or
			CreateFrame("Button", frameName .. "BigDebuffsRaid" .. i, frame, "CompactDebuffTemplate")
		big:ClearAllPoints()
		if i > 1 then
			if self.db.profile.raidFrames.anchor == "INNER" then
				big:SetPoint("BOTTOMLEFT", frame.BigDebuffs[i-1], "BOTTOMRIGHT", 0, 0)
			elseif self.db.profile.raidFrames.anchor == "LEFT" then
				big:SetPoint("BOTTOMRIGHT", frame.BigDebuffs[i-1], "BOTTOMLEFT", 0, 0)
			elseif self.db.profile.raidFrames.anchor == "RIGHT" then
				big:SetPoint("BOTTOMLEFT", frame.BigDebuffs[i-1], "BOTTOMRIGHT", 0, 0)
			end
		else
			if self.db.profile.raidFrames.anchor == "INNER" then
				big:SetPoint("BOTTOMLEFT", frame.debuffFrames[1], "BOTTOMLEFT", 0, 0)
			elseif self.db.profile.raidFrames.anchor == "LEFT" then
				big:SetPoint("BOTTOMRIGHT", frame, "BOTTOMLEFT", 0, 1)
			elseif self.db.profile.raidFrames.anchor == "RIGHT" then
				big:SetPoint("BOTTOMLEFT", frame, "BOTTOMRIGHT", 0, 1)
			end
		end

		big.cooldown:SetHideCountdownNumbers(not self.db.profile.raidFrames.cooldownCount)
		big.cooldown.noCooldownCount = not self.db.profile.raidFrames.cooldownCount

		big.cooldown:SetDrawEdge(false)
		frame.BigDebuffs[i] = big
		big:Hide()
		self.frames[frame] = true
		self:ShowBigDebuffs(frame)
	end
	return true
end

local pending = {}

hooksecurefunc("CompactUnitFrame_UpdateAll", function(frame)
	if InCombatLockdown() and not frame.BigDebuffs then
		if not pending[frame] then pending[frame] = true end
	else
		BigDebuffs:AddBigDebuffs(frame)
	end
end)

function BigDebuffs:PLAYER_TALENT_UPDATE()
	local specID = GetSpecializationInfo(GetSpecialization() or 1)
	self.specDispel = specID and specDispel[specID] and specDispel[specID]
end

function BigDebuffs:PLAYER_REGEN_ENABLED()
	for frame,_ in pairs(pending) do
		BigDebuffs:AddBigDebuffs(frame)
		pending[frame] = nil
	end
end

local function IsPriorityDebuff(id)
	for i = 1, #BigDebuffs.PriorityDebuffs do
		if id == BigDebuffs.PriorityDebuffs[i] then
			return true
		end
	end
end

hooksecurefunc("CompactUnitFrame_HideAllDebuffs", HideBigDebuffs)

local function IsDispellable(dispelType)
	if not dispelType or not BigDebuffs.specDispel then return end
	return BigDebuffs.specDispel[dispelType]
end

function BigDebuffs:GetDebuffSize(id, dispellable)
	if not self.Debuffs[id] then return end
	id = self.Debuffs[id].parent or id -- Check for parent spellID
	local category = self.Debuffs[id].type

	if not category or not self.db.profile.raidFrames[category] then return end

	-- Check for user set
	if self.db.profile.spells[id] then
		if self.db.profile.spells[id].raidFrames and self.db.profile.spells[id].raidFrames == 0 then return end
		if self.db.profile.spells[id].size then return self.db.profile.spells[id].size end
	end

	if self.Debuffs[id].noRaidFrames and not self.db.profile.spells[id].raidFrames then return end

	local dispellableSize = self.db.profile.raidFrames.dispellable[category]
	if dispellable and dispellableSize and dispellableSize > 0 then return dispellableSize end

	if self.db.profile.raidFrames[category] > 0 then
		return self.db.profile.raidFrames[category]
	end
end

-- For raid frames
function BigDebuffs:GetDebuffPriority(id)
	if not self.Debuffs[id] then return 0 end
	id = self.Debuffs[id].parent or id -- Check for parent spellID
	
	return self.db.profile.spells[id] and self.db.profile.spells[id].priority or
		self.db.profile.priority[self.Debuffs[id].type] or 0
end

-- For unit frames
function BigDebuffs:GetAuraPriority(id)
	if not self.Debuffs[id] then return end
	id = self.Debuffs[id].parent or id -- Check for parent spellID
	
	-- Make sure category is enabled
	if not self.db.profile.unitFrames[self.Debuffs[id].type] then return end

	-- Check for user set
	if self.db.profile.spells[id] then
		if self.db.profile.spells[id].unitFrames and self.db.profile.spells[id].unitFrames == 0 then return end
		if not self.db.profile.spells[id].unitFrames and self.Debuffs[id].noUnitFrames then return end
		if self.db.profile.spells[id].priority then return self.db.profile.spells[id].priority end
	end

	return self.db.profile.priority[self.Debuffs[id].type] or 0
end

function BigDebuffs:ShowBigDebuffs(frame)

	if not self.db.profile.raidFrames.enabled or not frame.debuffFrames or not frame.BigDebuffs then return end

	if not UnitIsPlayer(frame.displayedUnit) then
		return
	end	

	HideBigDebuffs(frame)

	local debuffs = {}
	local big
	local now = GetTime()
	local special

	for i = 1, 40 do
		local _,_,_,_, dispelType, _, time, caster, _,_, id = UnitDebuff(frame.displayedUnit, i)
		if id then
			local reaction = caster and UnitReaction("player", caster) or 0
			local friendlySmokeBomb = id == 88611 and reaction > 4
			local size = self:GetDebuffSize(id, IsDispellable(dispelType))
			if size and not friendlySmokeBomb then
				big = true
				local duration = time and time - now or 0
				tinsert(debuffs, { i, size, duration, self:GetDebuffPriority(id) })
			elseif self.db.profile.raidFrames.redirectBliz or
			(self.db.profile.raidFrames.anchor == "INNER" and not self.db.profile.raidFrames.hideBliz) then
				tinsert(debuffs, { i, self.db.profile.raidFrames.default, 0, 0 }) -- duration 0 to preserve Blizzard order
			end

			-- Set special debuff
			local k
			for j = 1, #self.SpecialDebuffs do
				if id == self.SpecialDebuffs[j] and
				self.db.profile.raidFrames.specialList[id] and
				not friendlySmokeBomb and
				(not k or j < k) then
					k = j
					special = i
				end
			end
		end
	end

	if #debuffs > 0 then
		local max = self.db.profile.raidFrames.maxDebuffs

		-- insert the special debuff if it exists and we have a big debuff
		if big and special then
			local size = self.db.profile.raidFrames.special
			-- remove duplicate
			for k,v in pairs(debuffs) do
				if v[1] == special then
					size = v[2] -- preserve the size
					debuffs[k] = nil
					break
				end
			end
			tinsert(debuffs, { special, size, 0, 0, true })
			max = max + 1 -- make room for the special debuff
		else
			special = nil
		end

		-- sort by priority > size > duration > index
		table.sort(debuffs, function(a, b)
			if a[4] == b[4] then
				if a[2] == b[2] then
					if a[3] < b[3] then return true end
					if a[3] == b[3] then return a[1] < b[1] end
				end
				return a[2] > b[2]
			end
			return a[4] > b[4]
		end)

		local index = 1

		if self.db.profile.raidFrames.hideBliz or
		self.db.profile.raidFrames.anchor == "INNER" or
		self.db.profile.raidFrames.redirectBliz then
			CompactUnitFrame_HideAllDebuffs(frame)
		end

		for i = 1, #debuffs do
			if not frame.BigDebuffs[index] then break end
			frame.BigDebuffs[index].baseSize = frame:GetHeight() * debuffs[i][2] * 0.01
			CompactUnitFrame_UtilSetDebuff(frame.BigDebuffs[index], frame.displayedUnit, debuffs[i][1], nil, false, false)
			frame.BigDebuffs[index].cooldown:SetSwipeColor(0, 0, 0, 0.7)
			index = index + 1
			if index > max then break end
		end

	end

end

-- We need to copy the entire function to avoid taint
hooksecurefunc("CompactUnitFrame_UpdateDebuffs", function(frame)
	if ( not frame.optionTable.displayDebuffs ) then
		CompactUnitFrame_HideAllDebuffs(frame);
		return;
	end
	
	local index = 1;
	local frameNum = 1;
	local filter = nil;
	local maxDebuffs = frame.maxDebuffs;
	--Show both Boss buffs & debuffs in the debuff location
	--First, we go through all the debuffs looking for any boss flagged ones.
	while ( frameNum <= maxDebuffs ) do
		local debuffName = UnitDebuff(frame.displayedUnit, index, filter);
		if ( debuffName ) then
			if ( CompactUnitFrame_UtilIsBossAura(frame.displayedUnit, index, filter, false) ) then
				local debuffFrame = frame.debuffFrames[frameNum];
				CompactUnitFrame_UtilSetDebuff(debuffFrame, frame.displayedUnit, index, filter, true, false);
				frameNum = frameNum + 1;
				--Boss debuffs are about twice as big as normal debuffs, so display one less.
				local bossDebuffScale = (debuffFrame.baseSize + BOSS_DEBUFF_SIZE_INCREASE)/debuffFrame.baseSize
				maxDebuffs = maxDebuffs - (bossDebuffScale - 1);
			end
		else
			break;
		end
		index = index + 1;
	end
	--Then we go through all the buffs looking for any boss flagged ones.
	index = 1;
	while ( frameNum <= maxDebuffs ) do
		local debuffName = UnitBuff(frame.displayedUnit, index, filter);
		if ( debuffName ) then
			if ( CompactUnitFrame_UtilIsBossAura(frame.displayedUnit, index, filter, true) ) then
				local debuffFrame = frame.debuffFrames[frameNum];
				CompactUnitFrame_UtilSetDebuff(debuffFrame, frame.displayedUnit, index, filter, true, true);
				frameNum = frameNum + 1;
				--Boss debuffs are about twice as big as normal debuffs, so display one less.
				local bossDebuffScale = (debuffFrame.baseSize + BOSS_DEBUFF_SIZE_INCREASE)/debuffFrame.baseSize
				maxDebuffs = maxDebuffs - (bossDebuffScale - 1);
			end
		else
			break;
		end
		index = index + 1;
	end
	
	--Now we go through the debuffs with a priority (e.g. Weakened Soul and Forbearance)
	index = 1;
	while ( frameNum <= maxDebuffs ) do
		local debuffName, _,_,_,_,_,_,_,_,_, id = UnitDebuff(frame.displayedUnit, index, filter);
		if ( debuffName ) then
			if ( CompactUnitFrame_UtilIsPriorityDebuff(frame.displayedUnit, index, filter) or IsPriorityDebuff(id)) then
				local debuffFrame = frame.debuffFrames[frameNum];
				CompactUnitFrame_UtilSetDebuff(debuffFrame, frame.displayedUnit, index, filter, false, false);
				frameNum = frameNum + 1;
			end
		else
			break;
		end
		index = index + 1;
	end
	
	if ( frame.optionTable.displayOnlyDispellableDebuffs ) then
		filter = "RAID";
	end
	
	index = 1;
	--Now, we display all normal debuffs.
	if ( frame.optionTable.displayNonBossDebuffs ) then
	while ( frameNum <= maxDebuffs ) do
		local debuffName, _,_,_,_,_,_,_,_,_, id = UnitDebuff(frame.displayedUnit, index, filter);
		if ( debuffName ) then
			if ( CompactUnitFrame_UtilShouldDisplayDebuff(frame.displayedUnit, index, filter) and not CompactUnitFrame_UtilIsBossAura(frame.displayedUnit, index, filter, false) and
				not CompactUnitFrame_UtilIsPriorityDebuff(frame.displayedUnit, index, filter) and not IsPriorityDebuff(id)) then
				local debuffFrame = frame.debuffFrames[frameNum];
				CompactUnitFrame_UtilSetDebuff(debuffFrame, frame.displayedUnit, index, filter, false, false);
				frameNum = frameNum + 1;
			end
		else
			break;
		end
		index = index + 1;
	end
	end
	
	for i=frameNum, frame.maxDebuffs do
		local debuffFrame = frame.debuffFrames[i];
		debuffFrame:Hide();
	end

	BigDebuffs:ShowBigDebuffs(frame)
end)

function BigDebuffs:IsPriorityBigDebuff(id)
	if not self.Debuffs[id] then return end
	id = self.Debuffs[id].parent or id -- Check for parent spellID
	return self.Debuffs[id].priority
end

function BigDebuffs:UNIT_AURA(_, unit)
	if not self.db.profile.unitFrames.enabled or not self.db.profile.unitFrames[unit] then return end

	local frame = self.UnitFrames[unit]
	if not frame then return end

	local now = GetTime()
	local left, priority, duration, expires, icon, debuff, buff = 0, 0

	for i = 1, 40 do
		-- Check debuffs
		local _,_, n, _,_, d, e, caster, _,_, id = UnitDebuff(unit, i)
		if id then
			if self.Debuffs[id] then
				local reaction = caster and UnitReaction("player", caster) or 0
				local friendlySmokeBomb = id == 88611 and reaction > 4
				local p = self:GetAuraPriority(id)
				if p and p >= priority and not friendlySmokeBomb then
					if p > priority or self:IsPriorityBigDebuff(id) or e == 0 or e - now > left then
						left = e - now
						duration = d
						debuff = i
						priority = p
						expires = e
						icon = n
					end
				end
			end
		end

		-- Check buffs
		local _,_, n, _,_, d, e, _,_,_, id = UnitBuff(unit, i)
		if id then
			if self.Debuffs[id] then
				local p = self:GetAuraPriority(id)
				if p and p >= priority then
					if p > priority or self:IsPriorityBigDebuff(id) or e == 0 or e - now > left then
						left = e - now
						duration = d
						debuff = i
						priority = p
						expires = e
						icon = n
						buff = true
					end
				end
			end
		end
	end

	if debuff and frame.anchor then
		if duration < 1 then duration = 1 end -- auras like Solar Beam don't have a duration
		if frame.blizzard then
			-- Blizzard Frame
			SetPortraitToTexture(frame.icon, icon)

			-- Adapt
			if Adapt and Adapt.portraits[frame.anchor] then
				Adapt.portraits[frame.anchor].modelLayer:SetFrameStrata("BACKGROUND")
			end
		else
			frame.icon:SetTexture(icon)
		end
		
		frame.cooldown:SetCooldown(expires - duration, duration)
		frame:Show()
		frame.cooldown:SetSwipeColor(0, 0, 0, 0.6)

		-- set for tooltips
		frame:SetID(debuff)
		frame.buff = buff
	else
		-- Adapt
		if frame.blizzard and Adapt and Adapt.portraits[frame.anchor] then
			Adapt.portraits[frame.anchor].modelLayer:SetFrameStrata("LOW")
		end

		frame:Hide()
	end
end

function BigDebuffs:PLAYER_FOCUS_CHANGED()
	self:UNIT_AURA(nil, "focus")
end

function BigDebuffs:PLAYER_TARGET_CHANGED()
	self:UNIT_AURA(nil, "target")
end

function BigDebuffs:UNIT_PET()
	self:UNIT_AURA(nil, "pet")
end

-- Show extra buffs
-- Setting frame.maxBuffs causes taint, so we need to copy entire function (FrameXML/CompactUnitFrame.lua)
hooksecurefunc("CompactUnitFrame_UpdateBuffs", function(frame)
	if not BigDebuffs.db.profile.raidFrames.increaseBuffs then return end

	if ( not frame.optionTable.displayBuffs ) then
		CompactUnitFrame_HideAllBuffs(frame);
		return;
	end
	
	local index = 1;
	local frameNum = 1;
	local filter = nil;
	while ( frameNum <= MAX_BUFFS ) do
		local buffName = UnitBuff(frame.displayedUnit, index, filter);
		if ( buffName ) then
			if ( CompactUnitFrame_UtilShouldDisplayBuff(frame.displayedUnit, index, filter) and not CompactUnitFrame_UtilIsBossAura(frame.displayedUnit, index, filter, true) ) then
				local buffFrame = frame.buffFrames[frameNum];
				CompactUnitFrame_UtilSetBuff(buffFrame, frame.displayedUnit, index, filter);
				frameNum = frameNum + 1;
			end
		else
			break;
		end
		index = index + 1;
	end
	for i=frameNum, MAX_BUFFS do
		local buffFrame = frame.buffFrames[i];
		if buffFrame then buffFrame:Hide() end
	end
end)

SLASH_BigDebuffs1 = "/bd"
SLASH_BigDebuffs2 = "/bigdebuffs"
SlashCmdList.BigDebuffs = function(msg)
	InterfaceOptionsFrame_OpenToCategory("BigDebuffs")
	InterfaceOptionsFrame_OpenToCategory("BigDebuffs")
end
